/***************************************************************************\
*                                                                           *
* BuilderX Version 4.0                                                      *
*                                                                           *
* Copyright (C) 1999 Xironic.                                               *
*                                                                           *
\***************************************************************************/
#ifndef BX3DFrameH
#define BX3DFrameH

#define D3D_OVERLOADS

#include "d3drmwin.h"
#include "dinput.h"
#include "bxerror.h"
#include <math.h>
#include <stdio.h>

#define SAFE_RELEASE(x) {if (x != NULL) {x->Release(); x = NULL;}}
#define SAFE_DELETE(x) {if (x != NULL) {delete x; x = NULL;}}
#define MSG(msg) Beep(0,0)


#if __BORLANDC__==0x520
 #undef PACKAGE
#define PACKAGE 
#endif




//---------------------------------------------------------------------------
double __fastcall Rad(double);
double __fastcall Grad(double);
double __fastcall TriangleField(double,double,double);
void __fastcall TransformVector(D3DVECTOR*,D3DMATRIX*);
void __fastcall RotationX(D3DVECTOR*,double);
void __fastcall RotationY(D3DVECTOR*,double);
void __fastcall RotationZ(D3DVECTOR*,double);
void __fastcall RotationXYZ(D3DVECTOR*,double,double,double);
void __fastcall ColorToRGB(TColor,float*,float*,float*);
TColor __fastcall RGBToColor(float,float,float);
TColor __fastcall D3DColorToColor(D3DCOLOR);
DWORD __fastcall RGBToColorR(int Res,int R,int G,int B);
bool __fastcall IsFileExist(AnsiString);
extern bool ShowErrorMessage;
extern HRESULT hRet;
bool CheckDXError(HRESULT hres,char* mess=NULL,bool ForceShow=false);
bool __fastcall BXCWE();
bool __fastcall CheckDX6Version();
AnsiString DownloadFile(AnsiString Url,int Flag);
AnsiString SearchFile(AnsiString File);
//---------------------------------------------------------------------------
class TBX3DCustomFrame;
extern LPDIRECT3DRMVIEWPORT2 GetViewport(TBX3DCustomFrame*);
extern TBX3DCustomFrame* GetFirstScene(TBX3DCustomFrame*);

#ifndef BX3DLocal
 extern LPDIRECT3DRMFRAME3 IVirtualScene;
 extern void SetVirtualScene(LPDIRECT3DRMFRAME3 IFrame);
 extern HINSTANCE dllError;
 extern char* (*proc)(HRESULT);
 extern LPDIRECT3DRM  FIDirect3DRM;
 extern LPDIRECT3DRM3 FIDirect3DRM3;
 extern bool MakeGlobalObjects();
 extern bool ReleaseGlobalObjects();
#endif

typedef void __fastcall (__closure *TPickEvent)(System::TObject* Sender,int Layer);
//---------------------------------------------------------------------------

class TBX3DCustomFrame;
class TBX3DFrame;

//TBX3DVector
//---------------------------------------------------------------------------
class TBX3DVector
{
  public:
    float X;
    float Y;
    float Z;
};

//TBX3DVectorProperty
//---------------------------------------------------------------------------
class PACKAGE TBX3DVectorProperty : public TPersistent
{
  protected:
    float FX;
    float FY;
    float FZ;
    float FModulus;
    virtual void __fastcall SetModulus(float);
    virtual float __fastcall GetModulus();
    virtual void __fastcall SetX(float);
    virtual void __fastcall SetY(float);
    virtual void __fastcall SetZ(float);
    virtual float __fastcall GetX()=0;
    virtual float __fastcall GetY()=0;
    virtual float __fastcall GetZ()=0;

    __property float Modulus={read=GetModulus,write=SetModulus};
    __property float X={read=GetX,write=SetX};
    __property float Y={read=GetY,write=SetY};
    __property float Z={read=GetZ,write=SetZ};

  public:
    TBX3DCustomFrame* OwnerFrame;
    virtual void __fastcall Assign(TPersistent* Source);
    virtual void __fastcall Change();
    __fastcall TBX3DVectorProperty(TBX3DCustomFrame*);
    __fastcall ~TBX3DVectorProperty();
};

//TBX3DVelocity
//---------------------------------------------------------------------------
class PACKAGE TBX3DVelocity : public TBX3DVectorProperty
{
 private:
    float __fastcall GetX();
    float __fastcall GetY();
    float __fastcall GetZ();

  public:
    void __fastcall Change();
    __fastcall TBX3DVelocity(TBX3DCustomFrame*);

  __published:
    __property Modulus;
    __property X;
    __property Y;
    __property Z;
};


//TBX3DPosition
//---------------------------------------------------------------------------
class PACKAGE TBX3DPosition : public TBX3DVectorProperty
{
  private:
    float FViewX;
    float FViewY;
    void __fastcall SetViewX(float);
    void __fastcall SetViewY(float);
    float __fastcall GetViewX();
    float __fastcall GetViewY();

    float __fastcall GetX();
    float __fastcall GetY();
    float __fastcall GetZ();

  public:
    virtual void __fastcall Assign(TPersistent* Source);
    void __fastcall Change();
    __fastcall TBX3DPosition(TBX3DCustomFrame*);
    __fastcall ~TBX3DPosition();

  __published:
    __property Modulus;
    __property X;
    __property Y;
    __property Z;
    __property float ViewX={read=GetViewX,write=SetViewX};
    __property float ViewY={read=GetViewY,write=SetViewY};
};

//TBX3DRotation
//---------------------------------------------------------------------------
class PACKAGE TBX3DRotation:public TBX3DVectorProperty
{
  private:
    float FAngle;
    void __fastcall SetAngle(float);
    float __fastcall GetAngle();
    float __fastcall GetX();
    float __fastcall GetY();
    float __fastcall GetZ();
  public:
    virtual void __fastcall Assign(TPersistent* Source);
    void __fastcall Change();
    __fastcall TBX3DRotation(TBX3DCustomFrame*);
    __fastcall ~TBX3DRotation();

  __published:
    __property X;
    __property Y;
    __property Z;
    __property float Angle={read=GetAngle,write=SetAngle};
};

//TBX3DOrientation
//---------------------------------------------------------------------------
class PACKAGE TBX3DOrientation:public TPersistent
{
  private:
    TBX3DCustomFrame* OwnerFrame;
    bool FReset;
    void __fastcall SetReset(bool);

    float FAngleRotX;
    float FAngleRotY;
    float FAngleRotZ;
    void __fastcall SetAngleRotX(float);
    void __fastcall SetAngleRotY(float);
    void __fastcall SetAngleRotZ(float);
    bool FAngleRotSelf;
    float FDirX;
    float FDirY;
    float FDirZ;
    float FUpX;
    float FUpY;
    float FUpZ;
    void __fastcall SetDirX(float);
    void __fastcall SetDirY(float);
    void __fastcall SetDirZ(float);
    void __fastcall SetUpX(float);
    void __fastcall SetUpY(float);
    void __fastcall SetUpZ(float);
    float __fastcall GetDirX();
    float __fastcall GetDirY();
    float __fastcall GetDirZ();
    float __fastcall GetUpX();
    float __fastcall GetUpY();
    float __fastcall GetUpZ();
    void __fastcall Update();
    void __fastcall UpdateRef();

    D3DVECTOR lprvDir;
    D3DVECTOR lprvUp;
    LPDIRECT3DRMFRAME3 RFrame;

  public:
    virtual void __fastcall Change();
    void __fastcall ChangeRot();
    __fastcall TBX3DOrientation(TBX3DCustomFrame*);
    __fastcall ~TBX3DOrientation();
    virtual void __fastcall Assign(TPersistent* Source);

  __published:
    __property bool Reset={read=FReset,write=SetReset};
    __property bool AngleRotSelf={read=FAngleRotSelf,write=FAngleRotSelf};
    __property float AngleRotX={read=FAngleRotX,write=SetAngleRotX};
    __property float AngleRotY={read=FAngleRotY,write=SetAngleRotY};
    __property float AngleRotZ={read=FAngleRotZ,write=SetAngleRotZ};
    __property float DirX={read=GetDirX,write=SetDirX};
    __property float DirY={read=GetDirY,write=SetDirY};
    __property float DirZ={read=GetDirZ,write=SetDirZ};
    __property float UpX={read=GetUpX,write=SetUpX};
    __property float UpY={read=GetUpY,write=SetUpY};
    __property float UpZ={read=GetUpZ,write=SetUpZ};
};

//TBX3DCustomFrame
//---------------------------------------------------------------------------
class PACKAGE TBX3DCustomFrame : public TComponent
{
  protected:
    TList* NotifyList;
    TPickEvent FOnPicked;
    TNotifyEvent FOnMove;

    TBX3DCustomFrame* FParentFrame;
    void __fastcall SetParentFrame(TBX3DCustomFrame*);
    bool FParentUpdate;

    LPDIRECT3DRMVIEWPORT2 FIViewport;
    LPDIRECT3DRMVIEWPORT2 GetIViewport();

    LPDIRECT3DRMFRAME3 FIScene;
    LPDIRECT3DRMFRAME3 GetIScene();

    LPDIRECT3DRMFRAME3 FIRefFrame;
    LPDIRECT3DRMFRAME3 GetIRefFrame();

    TColor FColor;
    virtual void __fastcall SetColor(TColor);
    virtual TColor __fastcall GetColor();
    virtual void __fastcall ChangeColor();

    TBX3DVelocity* FVelocity;
    void __fastcall SetVelocity(TBX3DVelocity*);
    TBX3DVelocity* __fastcall GetVelocity();

    TBX3DPosition* FPosition;
    void __fastcall SetPosition(TBX3DPosition*);

    TBX3DOrientation* FOrientation;
    void __fastcall SetOrientation(TBX3DOrientation*);

    TBX3DRotation* FRotation;
    void __fastcall SetRotation(TBX3DRotation*);


    virtual void __fastcall Change();
    virtual void __fastcall ChangeParentFrame();
    virtual void __fastcall ChangePosParams();
    virtual void __fastcall Create();
    virtual void __fastcall Init();


    LPDIRECT3DRMFRAME3 FIDirect3DRMFrame3;
    LPDIRECT3DRMFRAME3 __fastcall GetIDirect3DRMFrame3();

    void __fastcall Loaded(void);

//methods not for client

    void __fastcall SteepTime();

    void __fastcall RotAlpha(int);
    void __fastcall RotBetha(int);
    void __fastcall RotGamma(int);

  public:
    void __fastcall AddToNotify(TBX3DCustomFrame*);
    virtual void __fastcall Notification(TComponent* AComponent,TOperation Operation);
    void __fastcall SendNotification();
    virtual void __fastcall DoOnMove();
    virtual void __fastcall Picked(int Layer);

    __property TColor Color={read=GetColor,write=SetColor};

    __property LPDIRECT3DRMVIEWPORT2 IViewport={read=GetIViewport};
    __property LPDIRECT3DRMFRAME3 IReferenceFrame={read=GetIRefFrame};
    __property LPDIRECT3DRMFRAME3 IDirect3DRMFrame3={read=GetIDirect3DRMFrame3};
    __property TBX3DCustomFrame* ParentFrame={read=FParentFrame,write=SetParentFrame};
    __property bool ParentUpdate={read=FParentUpdate,write=FParentUpdate,default=true};    
    __property TBX3DPosition* Position={read=FPosition,write=SetPosition};
    __property TBX3DRotation* Rotation={read=FRotation,write=SetRotation};
    __property TBX3DOrientation* Orientation={read=FOrientation,write=SetOrientation};
    __property TBX3DVelocity* Velocity={read=FVelocity,write=SetVelocity};
    __property TPickEvent OnPicked={read=FOnPicked,write=FOnPicked};
    __property TNotifyEvent OnMove={read=FOnMove,write=FOnMove};
    __property LPDIRECT3DRMFRAME3 IScene={read=GetIScene};

//methods for client

    TBX3DPosition* GetRefPosition(TBX3DCustomFrame* ReferenceFrame);
    void __fastcall SetRefPosition(TBX3DCustomFrame* ReferenceFrame,TBX3DPosition* Position);

    TBX3DOrientation* GetRefOrientation(TBX3DCustomFrame* ReferenceFrame);
    void __fastcall SetRefOrientation(TBX3DCustomFrame* ReferenceFrame,TBX3DOrientation* Orientation);
    void __fastcall SetDirOrientation(D3DVECTOR VDir,D3DVECTOR VUp);

    TBX3DRotation* GetRefRotation(TBX3DCustomFrame* ReferenceFrame);
    void __fastcall SetRefRotation(TBX3DCustomFrame* ReferenceFrame,TBX3DRotation* Rotation);

    TBX3DVelocity* GetRefVelocity(TBX3DCustomFrame* ReferenceFrame);
    void __fastcall SetRefVelocity(TBX3DCustomFrame* ReferenceFrame,TBX3DVelocity* Velocity);


    void __fastcall Clone(TBX3DFrame **obj);

    __fastcall TBX3DCustomFrame(TComponent* Owner);
    __fastcall ~TBX3DCustomFrame();
};

//TBX3DFrame
//---------------------------------------------------------------------------
class PACKAGE TBX3DFrame : public TBX3DCustomFrame
{
  private:

  protected:
  public:
    __fastcall TBX3DFrame(TComponent* Owner);

 __published:
    __property ParentFrame;
    __property ParentUpdate;
    __property Position;
    __property Rotation;
    __property Orientation;
    __property Velocity;
    __property OnMove;
};

//---------------------------------------------------------------------------
#endif





